#include <iostream>
#include <string>
#include <boost/any.hpp>
using namespace std;
using namespace boost;

int main()
{
    try
    {
        any a;

        // int^̒l100
        a = 100;
        // int^̒lo
        cout << any_cast<int>(a) << endl;

        // string^̒l"Hello"
        a = string("Hello!");
        // string^̒lo
        cout << any_cast<string>(a) << endl;

        // double^̒l3.14
        a = 3.14;
        // string^̒loƂIH
        cout << any_cast<string>(a) << endl;
    }
    catch( bad_any_cast& e )
    {
        cout << e.what() << endl;
    }
    return 0;
}
