#include <iostream>
#include <string>
#include <boost/spirit.hpp>
using namespace std;
using namespace boost::spirit;

struct RegExpLiteral : grammar<RegExpLiteral>
{
    struct Bracket : closure<Bracket,char> { member1 br; };

    template<typename ScannerT>
      struct definition
      {
          rule<ScannerT> top;
          rule<ScannerT,Bracket::context_t> expr;
          definition( const RegExpLiteral& ) {
              using phoenix::arg1;
              top  = expr;
              expr = confix_p( '/', *anychar_p, '/' )
                   | 'm' >>
                     confix_p( anychar_p[expr.br=arg1],
                               *anychar_p,
                               f_ch_p(expr.br) );
          }
          const rule<ScannerT>& start() const  { return top; }
      };
};

int main()
{
    RegExpLiteral parser;
    // Psǂݍ
    string line;
    while( cout<<"# ", getline(cin, line) )
    {
        // Ps\
        parse_info<string::const_iterator> info =
            parse( line.begin(), line.end(), parser );
        // ͑ŜparsełA"OK"ƕ\
        cout << (info.full ? "OK" : "fail") << endl;
    }   // ȉEOF͂܂ŌJԂ
    return 0;
}
