#include <boost/preprocessor.hpp>

#define RETURN_ARG_MAX 3

#ifdef BOOST_PP_IS_ITERATING // JԂȂ炱

  #define ArgN        BOOST_PP_ITERATION()
  #define RETURN_TYPE BOOST_PP_CAT( T, BOOST_PP_DEC(ArgN) )
  #define RETURN_VAR  BOOST_PP_CAT( x, BOOST_PP_DEC(ArgN) )

  struct BOOST_PP_CAT( return_arg, ArgN )
  {
    #define GEN(z, n, d)                                                   \
      template< BOOST_PP_ENUM_PARAMS(n,typename T) >                       \
        RETURN_TYPE operator()( BOOST_PP_ENUM_BINARY_PARAMS(n,T,x) ) const \
          { return RETURN_VAR; }
    BOOST_PP_REPEAT_FROM_TO( ArgN, BOOST_PP_INC(RETURN_ARG_MAX), GEN, _ )
  };

  #undef ArgN
  #undef RETURN_TYPE
  #undef RETURN_VAR

#else // ͂
  #define BOOST_PP_ITERATION_LIMITS (1, RETURN_ARG_MAX)
  #define BOOST_PP_FILENAME_1       "pp6.h"
  #include BOOST_PP_ITERATE()
#endif
