#include <stdexcept>
#define BOOST_AUTO_TEST_MAIN
#include <boost/test/auto_unit_test.hpp>

#include "named_object.h"

BOOST_AUTO_UNIT_TEST( test_named_object )
{
    const named_object obj( "abc" );
    BOOST_CHECK_EQUAL( obj.get_name(), "abc" );

    BOOST_CHECK( obj.name_is("abc") );
    BOOST_CHECK( obj.name_is("ABC") );
    BOOST_CHECK( !obj.name_is("aaa") );

    BOOST_CHECK_THROW( named_object obj2( 0 ) , std::invalid_argument );
}
